# frozen_string_literal: true

class ActivityPub
  class Activity
    class Delete < ActivityPub::Activity
      # Los Delete se refieren a objetos.  Al eliminar un objeto,
      # cancelamos todas las actividades que tienen relacionadas.
      #
      # XXX: La actividad tiene una firma, pero la implementación no
      # está recomendada
      #
      # @todo Validar que le Actor corresponda con los objetos. Esto ya
      # lo haría la Social Inbox por nosotres.
      # @see {https://docs.joinmastodon.org/spec/security/#ld}
      def update_activity_pub_state!
        ActivityPub.transaction do
          ActivityPub::Object.find_by(uri: ActivityPub.uri_from_object(content['object']))&.activity_pubs&.find_each(&:remove!)

          activity_pub.remove!
        end
      end
    end
  end
end
